`timescale 1ps / 1ps
//*****************************************************************************
// File Name            : stepper_motor_uni.v
//-----------------------------------------------------------------------------
// Function             : unipolar stepper motor controller
//                        
//-----------------------------------------------------------------------------
// Designer             : yokomizo 
//-----------------------------------------------------------------------------
// History
// -.-- 2014/9/02@a
//*****************************************************************************

module stepper_motor_uni (
  clk,
  rst,
  cw,
  step,
  en,
  busy,
  m_a,
  m_a_b,
  m_b,
  m_b_b
);

  input clk;
  input rst;
  input cw;
  input [3:0] step;
  input en;
  output busy;
  output m_a;
  output m_a_b;
  output m_b;
  output m_b_b;
   
  reg en_dff;
  reg [3:0]m_out;
  reg [15:0] cnt_ms_base;
  reg [3:0] cnt_step_base;
  reg [11:0] cnt_step;
  wire    step_en;
  wire    ms_sig;
  wire rstb;
  
parameter p_1ms_cnt = 39999 ;//CLK=40MHẑƂ1ms̃JEgl
   
assign rstb = ~rst;	
	
//en̓   
   
always @ (posedge clk or negedge rstb )
if (rstb==1'b0) 
  en_dff <= 1'b0;
else
  en_dff <= en;
   
//1ms̃JE^   
always @ (posedge clk or negedge rstb )
if (rstb==1'b0) 
  cnt_ms_base <= 16'd0;
else
  if(en_dff==1'b1)
    if (ms_sig == 1'd1)
      cnt_ms_base <= 16'd0;
    else
      cnt_ms_base <= cnt_ms_base + 16'd1;
  else
      cnt_ms_base <= cnt_ms_base ;

assign  ms_sig =((cnt_ms_base == p_1ms_cnt)&&(en_dff==1'b1))?1'b1:1'b0; //1ms1clk1ɂȂ
   
//[^[JE^
always @ (posedge clk or negedge rstb )
if (rstb==1'b0) 
  cnt_step_base <= 4'd0;
else
  if((en_dff==1'b1)&&(ms_sig == 1'b1))
    //cnt_step_base_max̒lŎύX
    if (cnt_step_base >= step)
      cnt_step_base <= 4'd0;
    else
      cnt_step_base <= cnt_step_base + 4'd1;
  else  
    cnt_step_base <= cnt_step_base ;
	 
//
	  
assign busy = en_dff;

//[^[MMXVCl[u
assign step_en =  ((cnt_step_base == step)&&(en_dff == 1'b1)&&(ms_sig == 1'b1))?1'b1:1'b0;
   
//[^[]JE^   
always @ (posedge clk or negedge rstb )
if (rstb==1'b0) 
  cnt_step <= 12'h0;
else
    if (step_en == 1'b1)
      if(cw==1'b1)
        if (cnt_step == 12'hfff)
          cnt_step <= 12'h0;
        else
          cnt_step <= cnt_step + 12'd1;
      else
        if (cnt_step == 12'h0)
          cnt_step <= 12'hfff;
        else
          cnt_step <= cnt_step - 12'd1;
    else  
      cnt_step <= cnt_step ;

//pX
always @ (posedge clk or negedge rstb )
if (rstb==1'b0) 
  m_out <= 4'b1001;
else
   case (cnt_step[1:0])
      2'd0:m_out <= 4'b1001;
      2'd1:m_out <= 4'b0101;
      2'd2:m_out <= 4'b0110;
      2'd3:m_out <= 4'b1010;
    endcase // case(cnt_m_out)
	
assign m_a   = m_out[0];
assign m_a_b = m_out[1];
assign m_b   = m_out[2];   
assign m_b_b = m_out[3];
      
endmodule






